"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FilterGroup = void 0;
const react_1 = __importDefault(require("react"));
const InputGroup_1 = __importDefault(require("react-bootstrap/InputGroup"));
const Form_1 = __importDefault(require("react-bootstrap/Form"));
const Button_1 = __importDefault(require("react-bootstrap/Button"));
const FontAwesome_1 = __importDefault(require("./components/FontAwesome"));
function FilterGroup({ classes, filterText, placeholder, onChangeFilter, onClearFilter }) {
    return (react_1.default.createElement(InputGroup_1.default, { className: classes === null || classes === void 0 ? void 0 : classes.filterInputGroup },
        react_1.default.createElement(Form_1.default.Control, { type: "text", value: filterText, placeholder: placeholder, onChange: onChangeFilter, className: classes === null || classes === void 0 ? void 0 : classes.filterFormControl }),
        react_1.default.createElement(Button_1.default, { onClick: onClearFilter, className: classes === null || classes === void 0 ? void 0 : classes.filterClearButton },
            react_1.default.createElement(FontAwesome_1.default, { icon: "times", additionalClass: "fa-fw" }))));
}
exports.FilterGroup = FilterGroup;
function Filter({ filterable, filterText, placeholder = 'Enter text...', onChangeFilter, classes, CustomFilterGroup }) {
    // Event handlers.
    function onInputChange(e) {
        onChangeFilter(e.target.value);
    }
    function onClearFilter() {
        onChangeFilter('');
    }
    let filterRender = null;
    if (filterable) {
        const UsedFilterGroup = CustomFilterGroup || FilterGroup;
        filterRender = (react_1.default.createElement(UsedFilterGroup, { classes: classes, filterText: filterText, placeholder: placeholder, onChangeFilter: onInputChange, onClearFilter: onClearFilter }));
    }
    return filterRender;
}
exports.default = react_1.default.memo(Filter);
