"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PaginationOptsGroup = void 0;
const react_1 = __importDefault(require("react"));
const object_1 = require("./helpers/object");
const Form_1 = __importDefault(require("react-bootstrap/Form"));
function PaginationOptsGroup({ classes, labels, value, onChange, options }) {
    var _a, _b, _c;
    return (react_1.default.createElement(Form_1.default, { className: (0, object_1.makeClasses)('paginationOpts__root', classes === null || classes === void 0 ? void 0 : classes.paginationOptsForm) },
        react_1.default.createElement(Form_1.default.Group, { controlId: "formGroupPagination", className: classes === null || classes === void 0 ? void 0 : classes.paginationOptsFormGroup },
            react_1.default.createElement(Form_1.default.Label, { className: classes === null || classes === void 0 ? void 0 : classes.paginationOptsFormText }, ((_a = labels === null || labels === void 0 ? void 0 : labels.paginationOptions) === null || _a === void 0 ? void 0 : _a.beforeSelect) || 'Rows per page'),
            react_1.default.createElement(Form_1.default.Select, { name: "form-control-pagination", defaultValue: value, as: "select", placeholder: "select", onChange: onChange, className: classes === null || classes === void 0 ? void 0 : classes.paginationOptsFormControl }, options.map((option) => {
                const optionProps = {
                    key: `page-opt-${option}`,
                    value: option
                };
                return react_1.default.createElement("option", Object.assign({}, optionProps), option);
            })),
            ((_b = labels === null || labels === void 0 ? void 0 : labels.paginationOptions) === null || _b === void 0 ? void 0 : _b.afterSelect) && (react_1.default.createElement(Form_1.default.Text, { className: classes === null || classes === void 0 ? void 0 : classes.paginationOptsFormText }, (_c = labels === null || labels === void 0 ? void 0 : labels.paginationOptions) === null || _c === void 0 ? void 0 : _c.afterSelect)))));
}
exports.PaginationOptsGroup = PaginationOptsGroup;
function PaginationOpts({ labels, rowsPerPage, rowsPerPageOption, onRowsPerPageChange, classes, CustomPaginationOptsGroup }) {
    let renderedElements = null;
    if (rowsPerPage !== undefined) {
        let opts = [rowsPerPage];
        // Make sure there are no duplicates being pushed.
        if (rowsPerPageOption !== undefined) {
            rowsPerPageOption.forEach((opt) => {
                if (!opts.includes(opt) && typeof opt === 'number') {
                    opts.push(opt);
                }
            });
            // Order the pagination options ascending.
            opts = opts.sort((a, b) => {
                if (a < b) {
                    return -1;
                }
                else if (a > b) {
                    return 1;
                }
                return 0;
            });
        }
        // Only render option if the length is more than 1.
        if (opts.length > 1) {
            const UsedPaginationOpts = CustomPaginationOptsGroup || PaginationOptsGroup;
            renderedElements = (react_1.default.createElement(UsedPaginationOpts, { classes: classes, labels: labels, onChange: (e) => onRowsPerPageChange(Number(e.target.value)), options: opts, value: rowsPerPage }));
        }
    }
    return renderedElements;
}
exports.default = PaginationOpts;
