import React from 'react';
import InputGroup from 'react-bootstrap/InputGroup';
import Form from 'react-bootstrap/Form';
import Button from 'react-bootstrap/Button';
import FontAwesome from './components/FontAwesome';
export function FilterGroup({ classes, filterText, placeholder, onChangeFilter, onClearFilter }) {
    return (React.createElement(InputGroup, { className: classes === null || classes === void 0 ? void 0 : classes.filterInputGroup },
        React.createElement(Form.Control, { type: "text", value: filterText, placeholder: placeholder, onChange: onChangeFilter, className: classes === null || classes === void 0 ? void 0 : classes.filterFormControl }),
        React.createElement(Button, { onClick: onClearFilter, className: classes === null || classes === void 0 ? void 0 : classes.filterClearButton },
            React.createElement(FontAwesome, { icon: "times", additionalClass: "fa-fw" }))));
}
function Filter({ filterable, filterText, placeholder = 'Enter text...', onChangeFilter, classes, CustomFilterGroup }) {
    // Event handlers.
    function onInputChange(e) {
        onChangeFilter(e.target.value);
    }
    function onClearFilter() {
        onChangeFilter('');
    }
    let filterRender = null;
    if (filterable) {
        const UsedFilterGroup = CustomFilterGroup || FilterGroup;
        filterRender = (React.createElement(UsedFilterGroup, { classes: classes, filterText: filterText, placeholder: placeholder, onChangeFilter: onInputChange, onClearFilter: onClearFilter }));
    }
    return filterRender;
}
export default React.memo(Filter);
